import { SignedObject } from "./P2PTypes";
export interface Txs {
    txadd: AddNetworkTx[];
    txremove: RemoveNetworkTx[];
}
export interface AddNetworkTx<T = any> {
    hash: string;
    type: string;
    txData: T;
    cycle: number;
    priority: number;
    subQueueKey?: string;
}
export interface RemoveNetworkTx {
    txHash: string;
    cycle: number;
}
export declare type SignedAddNetworkTx = AddNetworkTx & SignedObject;
export declare type SignedRemoveNetworkTx = RemoveNetworkTx & SignedObject;
export interface NetworkTxEntry {
    hash: string;
    tx: AddNetworkTx;
}
export interface Record {
    txadd: AddNetworkTx[];
    txremove: RemoveNetworkTx[];
    txlisthash: string;
}
