/**
 * Safely converts a value to a string representation.
 *
 * @param val - The value to be converted.
 * @param options - The options for stringify (optional).
 * @returns The string representation of the value.
 */
export declare function safeStringify(val: any, options?: stringifyOptions): string;
/**
 * Safely parses a JSON string into an object.
 *
 * @param value - The JSON string to parse.
 * @returns The parsed JSON object.
 */
export declare function safeJsonParse(value: string): any;
export interface stringifyOptions {
    bufferEncoding: 'base64' | 'none';
}
/**
 * Revives specific types during JSON parsing.
 *
 * @param key - The key of the current property being parsed.
 * @param value - The value of the current property being parsed.
 * @returns The revived value, or the original value if no revival is needed.
 */
export declare function typeReviver(key: string, value: any): any;
